%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%changeallspecies.m

%disp('IM HERE in changeallspecies');
%return;   %debug line

newspeccode=get(gco,'user');

set(hf1,wbd,'',wbu,'',wbm,'');

alllegalflg=1;

%%%%%%%%%%%%%%%%%%%%%%%%
%find and set new species color

valid=0;

if ~isempty(newspeccode)
    for ii=1:listsize
        if sln(ii)==newspeccode
            newcolor=slc(ii,:);
            tempspecindex=ii;
            valid=1;
        end;
    end;
    if 120==newspeccode
        newcolor=slc(120,:);
        tempspecindex=120;
        valid=1;
    end;
end;

%check for legal species code

if valid==0
  msgbox('Illegal species code','WARNING');
  return;
end;

if valid~=0

  str8a='            You have selected ';
  str8b=num2str(tabselsz);
  str8c=' measurements!';
  str8d='ARE YOU SURE YOU WANT TO CHANGE THEM ALL TO SPECIES CODE ';
  str8e=num2str(newspeccode);
  str8abc=[str8a str8b str8c];
  str8de=[str8d str8e];
  str8=str2mat(str8abc,str8de);

  reply8=questdlg(str8,'WATCH OUT!!!','Yes','No','No');

  switch reply8

  case 'No'
    selcanall;
    return;

  case 'Yes'

%   temp save and restore samp no, current specindex and length,
%   so calcweight and length checking will work

    %snumold = snum;
    
    tempc=currentspecindex;
    if exist('templ')
%      templ=slenn;
      templ=slen;
    end;

    oldspeccode = [];

    for ti=1:tabselsz

      snumb=tabsel(ti);
      hlcur=findobj('userdata',snumb,'type','line');

%     find current species index
 
      for jj=1:listsize
        if sln(jj)==table(snumb,2)
          oldspecindex = jj;
          break;
        end
        if 120==table(snumb,2)     %to correct bad "code 999" data 
          oldspecindex = 120;
        end
      end

%     swap species indices

      oldspeccode(ti)=table(snumb,2);   %in case need to undo it
      table(snumb,2)=sln(newspeccode,:);

      if ~isempty(hlcur)
      %if hlcur(1)~=0
        hltag= get(hlcur,'tag');

        for ii=1:size(hltag,1)
          if strcmp(hltag(ii,:),'ln1')==1
              set(hlcur(ii),'linestyle','-','linewidth',1,...
                          'color',newcolor,'markerfacecolor',newcolor);
              if newspeccode == 120
                  set(hlcur(ii),'marker','o');
              else
                  set(hlcur(ii),'marker','x');
              end;
          end;
          if strcmp(hltag(ii,:),'ln2')==1
              set(hlcur(ii),'linestyle','none','linewidth',1,...
                            'color',newcolor,'markerfacecolor',newcolor);
              if newspeccode == 120
                  set(hlcur(ii),'marker','o');
              else
                  set(hlcur(ii),'marker','x');
              end;     
          end;
          if strcmp(hltag(ii,:),'ln3')==1
              set(hlcur(ii),'linestyle','--','linewidth',1,...
                            'color',newcolor,'markerfacecolor',newcolor);
              if newspeccode == 120
                  set(hlcur(ii),'marker','o');
              else
                  set(hlcur(ii),'marker','none');
              end;          
          end;
        end;
      end;

%     update the weight 

      currentspecindex=tempspecindex;
      slen=table(snumb,3);
      calcweight;
      table(snumb,4)=svol;

%     check for illegal lengths

      slen=table(snumb,3);

      legalflg=1;

      if slen1(currentspecindex)~=0
        if slen<jinm.spec.slen0(currentspecindex) | slen==0
          legalflg = 0;
          alllegalflg = 0;
          table(snumb,5)=legalflg;
          if slen~=0
            disp(['illegal length:  too short' char(beepchar)]);  %beep
          else
            disp(['illegal length:  length=0' char(beepchar)]);  %beep
          end   
          illegaltix=snumb;
          illegal;
        end;

        if slen>jinm.spec.slen1(currentspecindex)
          legalflg = 0;
          alllegalflg = 0;
          table(snumb,5)=legalflg;
          disp(['illegal length:  too long' char(beepchar)]);  %beep
          illegaltix=snumb;
          illegal;
        end;

        %if slen==0
        %  legalflg = 0;
        %  alllegalflg = 0;
        %  table(snumb,5)=legalflg;
        %  disp(['illegal length:  length=0' char(beepchar)]);  %beep
        %  snum=snumb;  %needed by illegal.m
        %  illegal;
        %end;

      end;

      %snum=snumold;
      
      currentspecindex=tempc;

%     update old and new species counts (if legal length)

      speccount(oldspecindex)=speccount(oldspecindex)-1;
      if hu3(oldspecindex)~=0
        set(hu3(oldspecindex),'str',num2str(speccount(oldspecindex)));
      end
      if alllegalflg==1
        speccount(tempspecindex)=speccount(tempspecindex)+1;
        if hu3(tempspecindex)~=0
          set(hu3(tempspecindex),'str',num2str(speccount(tempspecindex)));
        end
      end

    end;   %for loop

    if exist('templ')
      slen=templ;
    end; 

  end;  %end switch reply8

  writetable3;

  savecount=0;

  if alllegalflg==0
    st3='One or more samples was deleted because its length was illegal.';
    msgbox(st3,'WARNING');
  end

% change callbacks back to normal

  set(hselbycur,'enable','on');
  set(hselbynum,'enable','on');
  set(hselbyreg,'enable','on');

  set(hselok,'en','off');
  set(hselcan,'en','off');
  set(hchangespec,'en','off');

  delrect;

  set(hu4,'en','on');
  set(hu5,'en','on');
  set(hup,'en','on');
  set(hdn,'en','on');
  set(hlf,'en','on');
  set(hrt,'en','on');

  set(hzoom,'en','on');
  set(hnozoom,'en','on');


  cppending = 0;

  set(hstatus9,'str','READY');

  if ptmode==0
    setpmode0;
  end;

  if ptmode==1
    setpmode1;
  end;

  enablemodes;
  
  refresh;

end;

resetchangespec;

tabsel=[];
tabselsz=0;

%enable edit spec... menu item
set(hmen2,'enable','on');
