%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%changespparams.m

if exist('hf45') & ishandle(hf45)
    delete(hf45);
end
clear hf45

iesp2 = get(gco,'userdata');

%set aside 2 copies of current main window values
slctmp1      = jinm.spec.slc(iesp2,:);
slen0tmp1    = jinm.spec.slen0(iesp2);
slen1tmp1    = jinm.spec.slen1(iesp2);
listflagtmp1 = jinm.spec.listflag(iesp2);

slctmp2      = jinm.spec.slc(iesp2,:);
slen0tmp2    = jinm.spec.slen0(iesp2);
slen1tmp2    = jinm.spec.slen1(iesp2);
listflagtmp2 = jinm.spec.listflag(iesp2);

hf45=45;
figure(hf45);
set(hf45,'un','n','pos',[.5 .7 .30 .27] );
set(hf45,'numb','off','menubar','none',...
   'name','Set Length Limits, Button Color and Visibility');

colorchangestr = ...
    'set(hs1g,''backg'',slctmp1);set(hs1h,''backg'',slctmp1);';

hs1=uicontrol(hf45,'un','n','pos',[.0 .80 .50 .10],...
    'style','text','str','button color components');

  hs1a=uicontrol(hf45,'un','n','pos',[.0 .70 .2 .10],...
      'style','text','str','red   =');
  hs1b=uicontrol(hf45,'un','n','pos',[.0 .60 .2 .10],...
      'style','text','str','green =');
  hs1c=uicontrol(hf45,'un','n','pos',[.0 .50 .2 .10],...
      'style','text','str','blue  =');
  
  hs1d=uicontrol(hf45,'un','n','style','edit',...
    'pos',[.2 .70 .3 .10],'back','w','str',num2str(jinm.spec.slc(iesp2,1)),...
    'call','slctmp1(1)=str2num(get(hs1d,''str''));eval(colorchangestr);');

  hs1e=uicontrol(hf45,'un','n','style','edit',...
    'back','w','pos',[.2 .60 .3 .10],'str',num2str(jinm.spec.slc(iesp2,2)),...
    'call','slctmp1(2)=str2num(get(hs1e,''str''));eval(colorchangestr);');

  hs1f=uicontrol(hf45,'un','n','style','edit',...
    'back','w','pos',[.2 .50 .3 .10],'str',num2str(jinm.spec.slc(iesp2,3)),...
    'call','slctmp1(3)=str2num(get(hs1f,''str''));eval(colorchangestr);');

  hs1g=uicontrol(hf45,'un','n','style','text',...
    'pos',[.50 .90 .50 .10],'backg',jinm.spec.slc(iesp2,:),...
    'str',[num2str(jinm.spec.sln(iesp2)) blk blk blk blk blk jinm.spec.sla(iesp2,:)] );
  
  hs1h=uicontrol(hf45,'un','n','pos',[.00 .10 1.00 .10],'style','text',...
    'str',['Full Species Name:       ' jinm.spec.sld(iesp2,:)],...
    'backg',jinm.spec.slc(iesp2,:));

hs3=uicontrol(hf45,'un','n','pos',[.0 .90 .50 .10],'style','checkbox',...
    'str','show on main window','val',jinm.spec.listflag(iesp2),...
    'backg',jinm.spec.slc(iesp2,:),...
    'call','listflagtmp1=get(hs3,''val'');');

hs4=uicontrol(hf45,'un','n','pos',[.0 .00 1 .10],'style','text',...
    'backg',jinm.spec.slc(iesp2,:),...
    'str',['Weight (mg) as a function of length L (mm) =  ' volfn(iesp2,:)]);

hs2=uicontrol(hf45,'un','n','style','text','str','max and min length',...
    'pos',[.50 .80 .50 .10]);

  hs2a=uicontrol(hf45,'un','n','style','text','str','min =',...
    'pos',[.50 .70 .20 .10]);

  hs2b=uicontrol(hf45,'un','n','style','text','str','max =',...
    'pos',[.50 .60 .20 .10]);

  hs2d=uicontrol(hf45,'un','n','style','edit','back','w', ...
    'pos',[.70 .70 .30 .10],'str',num2str(jinm.spec.slen0(iesp2)), ...
    'call','slen0tmp1=str2num(get(hs2d,''str''));');

  hs2e=uicontrol(hf45,'un','n','style','edit','back','w', ...
    'pos',[.70 .60 .30 .10],'str',num2str(jinm.spec.slen1(iesp2)), ...
    'call','slen1tmp1=str2num(get(hs2e,''str''));');




happlysptemp=uicontrol(hf45,'un','n','pos',[.0 .40 .5 .1], ...
    'style','push','str','apply color/visibility change','call','applysptemp');

hundosptemp=uicontrol(hf45,'un','n','pos',[.0 .30 .5 .1], ...
    'style','push','str','undo color/visibility change','call','undosptemp');

hmakespperm=uicontrol(hf45,'un','n','pos',[.0 .20 .5 .1], ...
    'style','push','str','save color/visibility change','call','makespperm','foreg','r');


happlylntemp=uicontrol(hf45,'un','n','pos',[.5 .40 .5 .1], ...
    'style','push','str','apply length change','call','applylntemp');

hundolntemp=uicontrol(hf45,'un','n','pos',[.5 .30 .5 .1], ...
    'style','push','str','undo length change','call','undolntemp');

hmakelnperm=uicontrol(hf45,'un','n','pos',[.5 .20 .5 .1], ...
    'style','push','str','save length change','call','makelnperm','foreg','r');
