%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%digpart2.m

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%select and read image file

getinputfile;

set(hstatus9,'str','READING IMAGE FILE');

img = imread(imgpath);

set(hstatus8,'str',[imgfil '       ']);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%initial scaling, based on fixed scanner resolution

  [imheight,imwidth] =size(img);
  aspratio = imwidth/imheight;
  pixpercm = pixperinch/2.54000;
  pixpersq = cmpersq * pixpercm;
  cmperpix = 1/pixpercm;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%create image area

scrsize = get(0,'screensize');
xmen = figurewidth*scrsize(3);
ymen = figureheight*scrsize(4);
imagepart = ymen/xmen;

createimage;


%%%%%%%%%%%%%%%%%%%%%%%%
%%set up certain constants

sxcur='1';
sycur='1';
sx='1';
sy='1';
cx = str2num(sx);
cy = str2num(sy);
cellno = [cx cy];

cp1 = get(ha1,'currentpoint');
cp2 = cp1;
xx = cp1(1,1);
yy = cp1(1,2);

rangeflag = 0;
savecount = 0;
showallflag = 1;
cellnumflag=1;

newcmflag=0;
newspflag=0;
newlnflag=0;

visval='off';

%cppending = 0 => ready to digitize
%          = 1 => waiting for 2nd point
%          = 2 => waiting for species code
cppending = 0;

digmode = 0; %0 => spec sel before all pts; 1 => spec sel after each pt
ptmode  = 0; %0 => 2-point mode; 1 => n-point mode
perflag = 0; %0 => one-shot n-point mode; 1 => persistent n-point mode

setpmode0;
 
%snum = 1;

tabsel=[];
tabselsz=0;
tabix=0;

%reset color of mode buttons

%set(hdm0brd,'ba',[0 1 0]);
%set(hdm1brd,'ba',[.7 .7 .7]);

set(hpm0brd,'ba',[0 1 0]);
set(hpm1brd,'ba',[.7 .7 .7]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%
%create job information structures

getcm;

jincreate;

jinc=jin;
jinm=jin;

jinc.imgdir=imgdir;
jinc.imgfil=imgfil;


%%%%%%%%%%%%%%%%%%%%%%%%%%
%select output data files

set(hstatus9,'str','OPENING OUTPUT FILES');

inittable;

newstart4;

jinc.datdir=datdir;
jinc.datfil=datfil;

ascfil=[sscanf( datfil, '%[^.]' )  '.dat' ];
ascdir=datdir;

ascpath =[ascdir ascfil ];

%make sure ascii data file is not readonly

if exist(ascpath)==2
  fcheck=fopen(ascpath,'r+');
  if fcheck==-1;
     hwarndlg2=...
       warndlg('.dat file may be read only! Fix it before digitizing samples!');
     set(hwarndlg2,'unit','norm');
     set(hwarndlg2,'pos', get(hwarndlg2,'pos')+[0 .4 0 0] );
  else
    fclose(fcheck);
    clear fcheck;
  end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%
%read weight functions

readwgt;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%if it's a new job, initizlize tables,
% select a default menu file, and initialize species info

if rflag==1

  inittable;

  set(hstatus9,'str','SELECTING SPECIES BUTTONS');

  [spcfil,spcdir]=uigetfile('*.men','Select a Default Menu File');
  
  readspecies;
  
  %change white buttons to default color
  for ii=1:length(slc)
    if slc(ii,1)==1 & slc(ii,2)==1 & slc(ii,3)==1
      slc(ii,:) = defcolor;
    end;
  end;

  spec.listflag=listflag;
  spec.sln=sln;
  spec.sla=sla;
  spec.slen0=slen0;
  spec.slen1=slen1;
  spec.slc=slc;
  spec.sld=sld;

  jin.spec=spec;

  created=datestr(now);
  updated=datestr(now);

  jin.created=created;
  jin.updated=updated;

  jinc=jin;
  jinm=jin;

  genmenu3;

  set(hstatus9,'str','ENTER IMAGE PARAMETERS');
  
end;


%%%%%%%%%%%%%%%%%%
%display status boxes
%NOTE:  need to change READY to SETUP... when starting a NEW output file

set(hstatus8,'str',[imgfil '       ' datfil]);


%%%%%%%%%%%%%%%%%%%%%%%%
%turn off digitizing until startup params have been entered

set(hf1,wbd,'',wbm,'',wbu,'');

%set(hdm0,'en','off')
%set(hdm1,'en','off')

set(hmen5g1,'en','off')
set(hmen5g2,'en','off')

set(hpm0,'en','off')
set(hpm1,'en','off')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%for existing job, set all params to values from file 

if rflag==2

  plate=jin.plate;
  split=jin.split;
  xgridline0=jin.xgridline0;
  ygridline0=jin.ygridline0;
  pixperinch=jin.resolution;
  cmpersq=jin.cmpersq;

  set(hplatename,'style','text','back',[.6 1 1],'str',plate);
  set(hsplitname,'style','text','back',[.6 1 1],'str',split);
  set(hxoffset,'style','text','back',[.6 1 1],'str',num2str(xgridline0));
  set(hyoffset,'style','text','back',[.6 1 1],'str',num2str(ygridline0));
  set(hresolution,'style','text','back',[.6 1 1],'str',num2str(pixperinch));
  set(hcellsize,'style','text','back',[.6 1 1],'str',num2str(cmpersq));

  set(hsetparams,'en','off');

  colormap(jin.scm.cm*diag([jin.scm.rtint jin.scm.gtint jin.scm.btint])); 
        
  slc=jin.spec.slc;
  listflag=jin.spec.listflag;
  slen0=jin.spec.slen0;
  slen1=jin.spec.slen1;
  
  updated=datestr(now);

  jin.updated=updated;

  jin.version=verjin;

  jinm=jin;
  jinc=jin;

  cm=jin.scm.cm;
  xb=jin.scm.xb;
  yb=jin.scm.yb;
  xc=jin.scm.xc;
  yc=jin.scm.yc;
  gam=jin.scm.gam;
  gamflag=jin.scm.gamflag;
  rtint=jin.scm.rtint;
  gtint=jin.scm.gtint;
  btint=jin.scm.btint;
  
  docalib;

  dogrid;

  genmenu3;
  
  set(hstatus9,'str','REPLOTTING SAMPLES');

  drawnow;

  replotdata;
  
  set(hstatus9,'str','READY');
  
  %enable cursor for digitizing
 
  set(hf1,wbd,'getpt1');

%  set(hdm0,'en','on')
%  set(hdm1,'en','on')

  set(hmen5g1,'en','on')
  set(hmen5g2,'en','on')

  set(hpm0,'en','on')
  set(hpm1,'en','on')
 
  set(hready,'en','off');
 
end;

%turn on rescaling for use by selbyregion
 
set(hf1,'resizefcn','scalerect');

boxflag=1;  %for either endpoint in selected area

%used by writedata routines

ncells = ones(120,1);
tcells = 100;
vfilt = 1;
splitno = 1;;

specsplitno = ones(120,1);

ncells(:)=tcells*ncells(:);

sublist = cell(1,9);

%take this out if you don't want to change the names of species 111-119
% to Group totals, etc

%alterspecnames;

for j=1:9
  clab(j,:)=[' ' num2str(sln(j)) '-' sla(j,:) '  '];
end
for j=10:99
  clab(j,:)=[' ' num2str(sln(j)) '-' sla(j,:) ' '];
end
for j=100:120
  clab(j,:)=[' ' num2str(sln(j)) '-' sla(j,:)];
end

rlab=['0      ';'0.8e-5 ';'1.6e-5 ';'3.2e-5 ';'6.4e-5 ';'12.8e-5';...
      '25.6e-5';'51.2e-5';'.001   ';'.002   ';'.004   ';'.008   ';...
      '.016   ';'.032   ';'.064   ';'.128   ';'.256   ';'.512   ';...
      '1.000  ';'2.000  ';'4.000  ';'8.000  ';'16.00  ';'32.00  ';...
      '64.00  ';'128.0  ';'256.00 ';'512.00 ';'1000.0 ';'2000.0 '];
