%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%dispspecies.m

set(hstatus9,'str','MAKING SPEC/LEN EDITOR');

hf40=40;
figure(hf40);
set(hf40,'un','n','numb','off',...
  'name','Species Parameters (line colors and length limits)',...
  'pos',[.05 .20 .60 .70] );

hf45=45;
hf60=60;

set(hf40,'delete',...
    ['if ishandle(hf45) delete(hf45);end;' ...
     'if ishandle(hf60) delete(hf60);end;']);

hu21 = zeros(1,listsize);
hu24 = zeros(1,listsize);
hu25 = zeros(1,listsize);

ckboxcolor(1,:)=[1 0 0];    %red, for checkboxes with value=0 (off)
ckboxcolor(2,:)=[0 1 0];    %green, for checkboxes with value=1 (on)

slen0tmp=jinm.spec.slen0;
slen1tmp=jinm.spec.slen1;


hhdr2=uicontrol(hf40,'un','n','style','text','pos',[.00 .90 .25 .03],...
    'backg',[.8 .8 1],'str','Species/Lower Limit/Upper Limit   ');
hhdr2=uicontrol(hf40,'un','n','style','text','pos',[.25 .90 .25 .03],...
    'backg',[.8 .8 1],'str','Species/Lower Limit/Upper Limit    ');
hhdr2=uicontrol(hf40,'un','n','style','text','pos',[.50 .90 .25 .03],...
    'backg',[.8 .8 1],'str','Species/Lower Limit/Upper Limit    ');
hhdr2=uicontrol(hf40,'un','n','style','text','pos',[.75 .90 .25 .03],...
    'backg',[.8 .8 1],'str','Species/Lower Limit/Upper Limit    ');

x0 = .000;
y0 = .900;

icnt = 0;

for iesp=1:listsize
  icnt = icnt + 1;
  if icnt>30
      icnt = 1; x0 = x0 + .25 ; y0 = .900;
  end;
  y0 = y0 - .03;

  hu21(iesp) = uicontrol(hf40,'un','n','style','push','pos',[x0  y0 .11 .03], ...
        'fontunits','norm','fontweight','bold','fontsize',0.6,...
        'string',[num2str(jinm.spec.sln(iesp)) blk jinm.spec.sla(iesp,:)],...
        'backgroundcolor',jinm.spec.slc(iesp,:),...
        'userdata',iesp,'tag','he','callback','changespparams;');

  hu24(iesp) = uicontrol(hf40,'un','n','style','text','pos',[x0+.11  y0 .07 .03], ...
                    'fontunits','norm','fontweight','bold','fontsize',0.6, ...
                    'str',num2str(jinm.spec.slen0(iesp)),'back','w');

  hu25(iesp) = uicontrol(hf40,'un','n','style','text','pos',[x0+.18  y0 .07 .03], ...
                    'fontunits','norm','fontweight','bold','fontsize',0.6, ...
                    'str',num2str(jinm.spec.slen1(iesp)),'back',[1 1 .8]);
end;

%set callbacks for species codes 111 to 119
for iesp=111:119
    set(hu21(iesp),'callback','makesubtotwin;');
end

%disable lengths for species 111 to 119
for iesp = 111:119
    set(  hu24(iesp),  'enable',  'off'  );
    set(  hu25(iesp),  'enable',  'off'  );
end    

%color special buttons 
for i=111:119
  %set(hu21(i),'str',num2str(0),'backg',[1 .8 .8]);
  if isempty(sublist{i-110})     
       set(hu21(i),'str',num2str(0),'backg',[1 .8 .8]);
  else
       set(hu21(i),'str',num2str(sublist{i-110}),'backg',[1 .8 .8]);
  end
end
       

lastcol = 110;

%update status
set(hstatus9,'str','READY');

