%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%editcmap.m

hf20=20;
figure(hf20);

set(hf20,'un','n','numb','off','menubar','none',...
   'name','Edit Colormap','pos',[.65 .15 .32 .75]);

%%%%%%%%%%%%%%%%%%%%%%%%%
%set up image colormap axes and starting parameters

ha20=axes;
set(ha20,'units','norm','posit',[.1 .2 .85 .4]);
set(ha20,'xlim',[0 255]);
set(ha20,'ylim',[0 255]);
set(ha20, 'xtick',[0 31 63 95 127 159 191 223 255])
set(ha20, 'ytick',[0 31 63 95 127 159 191 223 255])

grid on
box on
hold on


cm = jinm.scm.cm;
xb = jinm.scm.xb;
xc = jinm.scm.xc;
yb = jinm.scm.yb;
yc = jinm.scm.yc;
gam = jinm.scm.gam;
gamflag = jinm.scm.gamflag;
rtint=jinm.scm.rtint;
gtint=jinm.scm.gtint;
btint=jinm.scm.btint;


colorfactor=[rtint gtint btint];

cf=diag(colorfactor);
cmt=cm*cf;
colormap(cmt);

hcbar=colorbar('h');
set(hcbar,'xtick',[]);


%hu21 = zeros(1,listsize);
%hu22 = zeros(1,listsize);
%hu23 = zeros(1,listsize);
%hu24 = zeros(1,listsize);
%hu25 = zeros(1,listsize);


hmakecmperm=uicontrol(hf20,'un','n','pos',[.100 .061 .30 .03], ...
    'style','push','str','save','call','makecmperm', ...
    'foreg','r');

hresetcm=uicontrol(hf20,'un','n','pos',[.100 .031 .30 .03], ...
    'style','push','str','reset','call','resetcm', ...
    'foreg','r');

happlycmtemp=uicontrol(hf20,'un','n','pos',[.100 .001 .30 .03], ...
    'style','push','str','apply','call','applycmtemp');

hundocmtemp=uicontrol(hf20,'un','n','pos',[.400 .001 .30 .03], ...
    'style','push','str','undo','call','undocmtemp','en','off');

hclosecmwin=uicontrol(hf20,'un','n','pos',[.700 .001 .30 .03], ...
    'style','push','str','close','call','closecmwin');


%%%%%%%%%%%%%%%%%%%%%%%%
%display job info

gy=[.7 .7 .7];
yl=[1 1 .5];

%creation date and time
hjtimetxt=uicontrol(hf20,'un','n','style','text',...
  'pos',[.0 .97 .30 .03],'str','Created');
hjtime=uicontrol(hf20,'un','n','style','text','back',yl,...
  'pos',[.30 .97 .70 .028],'str',created);

%update date and time
hjupdatxt=uicontrol(hf20,'un','n','style','text',...
  'pos',[.0 .94 .30 .03],'str','Last Updated');
hjupda=uicontrol(hf20,'un','n','style','text','back',yl,...
  'pos',[.30 .94 .70 .028],'str',updated);


%image file directory 
hjimagedirtxt=uicontrol(hf20,'un','n','style','text',...
  'pos',[.0 .91 .30 .03],'str','Image Directory');
hjimagedir=uicontrol(hf20,'un','n','style','text','back',yl,...
  'pos',[.30 .91 .70 .028],'str',imgdir);

%image file name
hjimagetxt=uicontrol(hf20,'un','n','style','text',...
  'pos',[.0 .88 .30 .03],'str','Image File');
hjimage=uicontrol(hf20,'un','n','style','text','back',yl,...
  'pos',[.30 .88 .70 .028],'str',imgfil);


%data file directory 
hjdatadirtxt=uicontrol(hf20,'un','n','style','text',...
  'pos',[.0 .85 .30 .03],'str','Data Directory');
hjdatadir=uicontrol(hf20,'un','n','style','text','back',yl,...
  'pos',[.30 .85 .70 .028],'str',datdir);

%data file name 
hjdatatxt=uicontrol(hf20,'un','n','style','text',...
  'pos',[.0 .82 .30 .03],'str','Data File');
hjdata=uicontrol(hf20,'un','n','style','text','back',yl,...
  'pos',[.30 .82 .70 .028],'str',datfil);

%%%%%%%%%%%%%%%%%

ccolor=yl;

%plate name
hjplatetxt=uicontrol(hf20,'un','n','style','text',...
  'pos',[.00 .79 .30 .03],'str','Plate Name');
hjplate=uicontrol(hf20,'un','n','style','text','back',ccolor,...
  'pos',[.30 .79 .70 .028],'str',plate);

%split name
hjsplittxt=uicontrol(hf20,'un','n','style','text',...
  'pos',[.00 .76 .30 .03],'str','Split Name');
hjsplit=uicontrol(hf20,'un','n','style','text','back',ccolor,...
  'pos',[.30 .76 .70 .028],'str',split);

%origin x-offset
hjxgridtxt=uicontrol(hf20,'un','n','style','text',...
  'pos',[.00 .73 .30 .03],'str','X-Offset (pixels)');
hjxgrid=uicontrol(hf20,'un','n','style','text','back',ccolor,...
  'pos',[.30 .73 .70 .028],'str',num2str(xgridline0));

%origin y-offset
hjygridtxt=uicontrol(hf20,'un','n','style','text',...
  'pos',[.00 .70 .30 .03],'str','Y-Offset (pixels)');
hjygrid=uicontrol(hf20,'un','n','style','text','back',ccolor,...
  'pos',[.30 .70 .70 .028],'str',num2str(ygridline0));


%pixel resolution
hjrestxt=uicontrol(hf20,'un','n','style','text',...
  'pos',[.00 .67 .30 .03],'str','Pixel Res (pixels/inch)');
hjres=uicontrol(hf20,'un','n','style','text','back',ccolor,...
  'pos',[.30 .67 .70 .028],'str',num2str(pixperinch));


%grid size
hjgsizetxt=uicontrol(hf20,'un','n','style','text',...
  'pos',[.00 .64 .30 .03],'str','Grid Size (centimeters)');
hjgsize=uicontrol(hf20,'un','n','style','text','back',ccolor,...
  'pos',[.30 .64 .70 .028],'str',num2str(cmpersq));


%%%%%%%%%%%%%%%%%%%%%%%%%%
%set up image colormap


p3=[.09 .03];
p4=[.12 .03];
p6=[.18 .03];
p7=[.21 .03];
p10=[.30 .03];


hc5=uicontrol(hf20,'un','n','pos',[.10 .15 p10],'style','push','str','gamma',...
             'call','appcmon;gammacm');

  hc5a=uicontrol(hf20,'un','n','pos',[.10 .12 p10],'style','edit','back','w',...
             'str',num2str(gam),...
             'call','gam=str2num(get(gco,''str''));');


hc6=uicontrol(hf20,'un','n','pos',[.40 .15 p10],'style','push','str','linear',...
             'call','appcmon;linearcm');

  hc6a0=uicontrol(hf20,'un','n','pos',[.40 .12 p4],'style','text','str','left x');
  hc6b0=uicontrol(hf20,'un','n','pos',[.40 .09 p4],'style','text','str','left y');
  hc6c0=uicontrol(hf20,'un','n','pos',[.40 .06 p4],'style','text','str','right x');
  hc6d0=uicontrol(hf20,'un','n','pos',[.40 .03 p4],'style','text','str','right y');

  hc6a=uicontrol(hf20,'un','n','pos',[.52 .12 p6],'style','edit','back','w',...
             'str',num2str(xb),...
             'call','xb=str2num(get(gco,''str''));');

  hc6b=uicontrol(hf20,'un','n','pos',[.52 .09 p6],'style','edit','back','w',...
             'str',num2str(yb),...
             'call','yb=str2num(get(gco,''str''));');

  hc6c=uicontrol(hf20,'un','n','pos',[.52 .06 p6],'style','edit','back','w',...
             'str',num2str(xc),...
             'call','xc=str2num(get(gco,''str''));');

  hc6d=uicontrol(hf20,'un','n','pos',[.52 .03 p6],'style','edit','back','w',...
             'str',num2str(yc),...
             'call','yc=str2num(get(gco,''str''));');


hc7=uicontrol(hf20,'un','n','pos',[.70 .15 p10],'style','push','str','tint',...
             'call','appcmon;tintcm');

  hc7a0=uicontrol(hf20,'un','n','pos',[.70 .12 p3],'style','text','str','red');
  hc7b0=uicontrol(hf20,'un','n','pos',[.70 .09 p3],'style','text','str','green');
  hc7c0=uicontrol(hf20,'un','n','pos',[.70 .06 p3],'style','text','str','blue');

  hc7a=uicontrol(hf20,'un','n','pos',[.79 .12 p7],'style','edit','back','w',...
             'str',num2str(rtint));

  hc7b=uicontrol(hf20,'un','n','pos',[.79 .09 p7],'style','edit','back','w',...
             'str',num2str(gtint));

  hc7c=uicontrol(hf20,'un','n','pos',[.79 .06 p7],'style','edit','back','w',...
             'str',num2str(btint));



hp0=plot([0:255],255*cm(:,3),'b');

hp1=plot(xb,yb,'bo');  set(hp1,'markersize',12,'linewidth',3);

hp2=plot(xc,yc,'bo');  set(hp2,'markersize',12,'linewidth',3);


%activate color cursor buttons

set(hf20,wbd,'chg1',wbm,'',wbu,'chg3');


