%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%fixweights.m

%AUXILLARY PROGRAM to repair weight values in older mat files

%get filenames

fwin = 1;

[infile,inpath]=uigetfile('*.mat','Select INPUT FILE');
sinp= [inpath infile];

   %[outfile,outpath]=uiputfile('*.mat','Select OUTPUT FILE');
   %sout= [outpath outfile];
   %[logfile,logpath]=uiputfile('*.mat','Select LOG FILE');
   %slog= [logpath logfile];

sout=[sinp '.mod'];
slog=[sinp '.log'];

if exist(sout)==2
  fprintf(fwin,'WARNING:  OUTPUT FILE ALREADY EXISTS!!\n');
  fprintf(fwin,'filename =  %s\n',sout);
  sok=input('Do you want to overwrite it (y/n)?\n','s');
  if ~(sok=='y' | sok=='Y')
    return;
  end;
end;


   %sinp =input('enter input file name:\n','s');
   %sout=input('enter output file name:\n','s');
   %slog=input('enter log file name:\n','s');

eps10 = 1.0e-10;

tixmax = 50000;

newwgttable=zeros(tixmax,1);

%%%%%%%%%%%%%%%%%%%%%

%read species table and weigght formulae

%choose default files

spcfil=0;
spcdir=0;
wgtfil=0;
wgtdir=0;

listsize=120;

readspecies;
readwgt;

%%%%%%%%%%%%%%%%%%%%%

%read data tables

eval(['load ''' sinp ''' -mat']);

%%%%%%%%%%%%%%%%%%%%

%open output files and start log

flog=fopen(slog,'w');

%matlab window

fprintf(fwin,'\n');
fprintf(fwin,'FIXWEIGHTS program log\n');
fprintf(fwin,'\n');

fprintf(fwin,'input  file = %s\n',sinp);
fprintf(fwin,'output file = %s\n',sout);
fprintf(fwin,'log    file = %s\n',slog);
fprintf(fwin,'\n');
fprintf(fwin,...
  'snumber,species,nminor,nmajor,oldlen,lenminor,lenmajor,oldwgt,newwgt\n');
fprintf(fwin,'\n');

%log file

fprintf(flog,'\n');
fprintf(flog,'\n');
fprintf(flog,'FIXWEIGHTS program log\n');
fprintf(flog,'\n');

fprintf(flog,'input  file = %s\n',sinp);
fprintf(flog,'output file = %s\n',sout);
fprintf(flog,'log    file = %s\n',slog);
fprintf(flog,'\n');
fprintf(flog,...
  'snumber,species,nminor,nmajor,oldlen,lenminor,lenmajor,oldwgt,newwgt\n');
fprintf(flog,'\n');


%%%%%%%%%%%%%%%%%%%%%%%%

%scan and correct data

for i=1:tixmax

  snumber  =table(i,1);

%    skip over null samples (i.e. those with no sample number)
 if snumber~=0       

  spxxx    =table(i,2);
  oldlen   =table(i,3);
  oldwgt   =table(i,4);

  majorptr =table(i,7);
  nmajor   =table(i,8);

  minorptr =table(i,9);
  nminor   =table(i,10);

  valid=sign(table(i,8));

  newwgt=0;

  if valid<0
    nmajor=-nmajor;
    nminor=-nminor;
  end

  lenmajor=0;

  if nmajor>=2
    for j = majorptr+1 : majorptr+nmajor-1
      dx = tablemajor(j,1)-tablemajor(j-1,1);
      dy = tablemajor(j,2)-tablemajor(j-1,2);
      lenmajor = lenmajor + sqrt( (dx^2 + dy^2) );
    end;
  end;

  lenminor=0;

  if nminor>=2
    for j = minorptr+1 : minorptr+nminor-1
      dx = tableminor(j,1)-tableminor(j-1,1);
      dy = tableminor(j,2)-tableminor(j-1,2);
      lenminor = lenminor + sqrt( (dx^2 + dy^2) );
    end;
  end;

  slen=lenminor;

  currentspecindex=spxxx;
  if currentspecindex==999
    currentspecindex=120;
  end;

  %calculate weight;
  calcweight;

  newwgt=svol;

   newwgttable(i)=newwgt;

  if abs(oldwgt-newwgt)>eps10
    fprintf(fwin,'    %4g %3g %3g %3g %8g %8g %8g  %8g %8g',...
        i,spxxx,nminor,nmajor,oldlen,lenminor,lenmajor,oldwgt,newwgt);
    fprintf(flog,'    %4g %3g %3g %3g %8g %8g %8g  %8g %8g',...
        i,spxxx,nminor,nmajor,oldlen,lenminor,lenmajor,oldwgt,newwgt);
    if valid<0
      fprintf(fwin,' (invalid sample; deleted!)\n');
      fprintf(flog,' (invalid sample; deleted!)\n');
    else
      fprintf(fwin,'\n');
      fprintf(flog,'\n');
    end;
  end
 end;  %end skip null samples
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%revise and save the mat file

table(:,4) = newwgttable;

%may have to change directories on PC, and then change back (or not allow it)

%eval( ['save ''' sout  ''' tablehdr table tablemajor tableminor jin'] );
eval( ['save ''' sout  ''' table tablemajor tableminor jin'] );

fclose(flog);

