%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%
%hist4.m

%set up weight bin boundaries

blimswgt = [ 0.8e-5 1.6e-5 3.2e-5 6.4e-5 12.8e-5 25.6e-5 51.2e-5 ...
          .001 .002 .004 .008 .016 .032 .064 .128 .256 .512 ...
         1 2 4 8 16 32 64 128 256 512 1000 2000];
nwgtbins = length(blimswgt) + 1;
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%set up length bin boundaries

nbin = (xmx-xmn)*ndel + 1;

if xtyp == 1
    %case 1 test (linear scale)
    blimslen1=[];
    for ibin = 1:nbin
        iexp(ibin) = xhscfa(xscf)*( xmn + (ibin-1)/ndel );      
        blimslen1(ibin) = iexp(ibin);
    end
    nlenbins1 = length(blimslen1) + 1;
end

if xtyp == 2
    %case 2 test (log10 scale, standard spacing ???)
    blimslen2=[];
    for ibin = 1:nbin
        iexp(ibin) = xmn + (ibin-1)/ndel;      
        blimslen2(ibin) = 10^iexp(ibin);
    end
    nlenbins2 = length(blimslen2) + 1;
end

if xtyp == 3 
   %case 3b test  (log10 scale, with equal divisions per decade ???)
    blimslen3=[];

    jjj = 1;
    for x = xmn:xmx-1
        del = 9/ndel*10^x;
        %fprintf(1,'%d %d\n',x,del);
        for k=1:ndel
            blimslen3(jjj)=10^x+(k-1)*del;
            jjj = jjj+1;
        end
    end
    blimslen3(jjj)=10^xmx;
    nlenbins3 = length(blimslen3) + 1;
end

%NOW PICK ONE OF THE THREE AND SEE WHAT HAPPENS

if xtyp==1 blimslen = blimslen1; nlenbins = nlenbins1; end;
if xtyp==2 blimslen = blimslen2; nlenbins = nlenbins2; end;
if xtyp==3 blimslen = blimslen3; nlenbins = nlenbins3; end;


%make the row labels

if xlab == 1
    %sss=sprintf('%14.6f\n',[0 blimslen]);
    %sss2=reshape(sss,15,nlenbins)';
    %lenlab=strjust(sss2(:,1:14),'left');
    sss2=sprintf('%s ','-Infy');
    for jj=2:length(blimslen)+1
        sss=sprintf('%f',blimslen(jj-1));
        sss2=char(sss2,sss);
        %lenlab=strjust(sss2(:,1:14),'left');
        lenlab=sss2;
    end
end

if xlab == 2
    %sss=sprintf('%14.6f\n',[0 log10(blimslen)]);
    %sss2=reshape(sss,15,nlenbins)';
    %lenlab=strjust(sss2(:,1:14),'left');
    sss2=sprintf('%s ','-Infy');
    for jj=2:length(blimslen)+1
        sss=sprintf('%f',log10(blimslen(jj-1)));
        sss2=char(sss2,sss);
        %lenlab=strjust(sss2(:,1:14),'left');
        lenlab=sss2;
    end
end

if xlab == 3
    sss2=sprintf('%f_(%s)',0,'-Infy');
    for jj=2:length(blimslen)+1
        sss=sprintf('%f_(%f)',blimslen(jj-1),log10(blimslen(jj-1)));
        sss2=char(sss2,sss);
        %lenlab=strjust(sss2(:,1:14),'left');
        lenlab=sss2;
    end
end

if xlab == 4
    sss2=sprintf('%s_(%f)','-Infy',0);
    for jj=2:length(blimslen)+1
        sss=sprintf('%f_(%f)',log10(blimslen(jj-1)),blimslen(jj-1));
        sss2=char(sss2,sss);
        %lenlab=strjust(sss2(:,1:14),'left');
        lenlab=sss2;
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

rawlencnt=zeros(120,nlenbins);   % raw       counts in each length bin
corlencnt=zeros(120,nlenbins);   % corrected counts in each length bin

rawwgtcnt=zeros(120,nwgtbins);   % raw       counts in each weight bin
corwgtcnt=zeros(120,nwgtbins);   % corrected counts in each weight bin

rawwgt=zeros(120,nwgtbins);      % raw       weights in each weight bin
corwgt=zeros(120,nwgtbins);      % corrected weights in each weight bin

rncells=(1.0)./ncells;

rvf=1/vfilt;
tcl=tcells;

for j=1:120

%    If there's no weight formula for this species, then cwgt{1,j}
%    will be all zeros and nowgtflag(j) will be 1.

      splitfactor=1/specsplitno(j);

      %lentmp = clen{1,j};
      lentmp = clen{j};
      [lencount,lensum] = hgram3(lentmp,blimslen);
      rawlencnt(j,:) = lencount;
      corlencnt(j,:) = tcl*rvf*splitfactor.*rncells(j).*rawlencnt(j,:);
      
      %wgttmp = cwgt{1,j};
      wgttmp = cwgt{j};
      [wgtcount,wgtsum] = hgram3(wgttmp,blimswgt);
      rawwgtcnt(j,:) = wgtcount;
      rawwgt(j,:)    = wgtsum;      
      corwgtcnt(j,:) = tcl*rvf*splitfactor.*rncells(j).*rawwgtcnt(j,:);      
      corwgt(j,:)    = tcl*rvf*splitfactor.*rncells(j).*rawwgt(j,:);
      
end

corlencnttot = zeros(1,120);
corwgtcnttot = zeros(1,120);
corwgttot    = zeros(1,120);

%for i=1:dht 

  for j=1:120
    corlencnttot(1,j) = sum(corlencnt(j,:));
    corwgtcnttot(1,j) = sum(corwgtcnt(j,:));
    corwgttot(1,j)    = sum(corwgt(j,:)); 
  end;
  
%end

%disp('histograms complete')

