%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%newstart4.m

%determine if this is a new or existing job

reply=questdlg('Is this a New or Existing Job?','Job Type',...
               'New','Existing','Abort','Existing');
switch reply
  case '';         rflag=0;
  case 'New';      rflag=1;
  case 'Existing'; rflag=2;
  case 'Abort';    rflag=3;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%set up a new output file

if rflag==1
  if strcmp(computer,'PCWIN')==1
    [datfil,datdir]=uiputfile([imgdir '\*.mat'],'Pick a new output file name');
  else
    [datfil,datdir]=uiputfile([imgdir '*.mat'],'Pick a new output file name');

  end;

  if strcmp(datfil,sscanf(datfil,'%[^.]'))
    datfil=[datfil '.mat'];
  end;

  datpath=[datdir datfil];

  if isnumeric(datpath)                                   %canceled or x'ed the window
    newstart4

  elseif ~isnumeric(datpath) & ~exist(datpath,'file')     %OK, file doesn't exist

    newflag=1;

  elseif ~isnumeric(datpath) & exist(datpath,'file')==2   %file exists; confirm&backup 

    reply=questdlg(str2mat('DO YOU REALLY WANT TO OVERWRITE THIS FILE?',...
                           'IF YOU DO, YOU WILL DELETE ALL PREVIOUSLY',...
                           'DIGITIZED DATA IN THE FILE!'),...
                           'WARNING','Yes','No','Quit Pgm','No');
    switch reply

      case 'Yes'
        pbk=datdir;
        fbk=[sscanf(datfil,'%[^.]') '.mbk'];
        pfback=[pbk fbk];
        
        eval(['load ''' datpath ''' -mat']);
        
        set(hstatus9,'str','BACKING UP TO .mbk FILE');

        newflag=1;

        %eval(['save ''' pfback ''' tablehdr table tablemajor tableminor jin -mat']);
        eval(['save ''' pfback ''' table tablemajor tableminor jin -mat']);
        
      case 'No'
        newstart4

      case 'Quit Pgm'
        reply2=questdlg('Do you really want to QUIT?','WARNING','Yes','No','No');
        switch reply2;
            case 'Yes'; close all; clear ;
            case 'No'; newstart4;
        end; 
        %switch reply2; case 'Yes'; quit; case 'No'; newstart4; end; 

    end   %switch reply

  else                                            %???, so redo
    newstart4
  end

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%continue with an existing output file

if rflag==2
  if strcmp(computer,'PCWIN')==1
    [datfil,datdir]=uigetfile([imgdir '*.mat'],'Pick an existing output file name');
  else
    [datfil,datdir]=uigetfile([imgdir '*.mat'],'Pick an existing output file name');
  end

  datpath=[datdir datfil];

  if isnumeric(datpath)                                   %canceled or x'ed the window
    newstart4

  elseif ~isnumeric(datpath) & ~exist(datpath,'file')==2  %file doesnt exist(not allowed)
    newstart4

  elseif ~isnumeric(datpath) & exist(datpath,'file')      %file exists, so use it (and back it up)
     
    pbk=datdir;
    fbk=[sscanf(datfil,'%[^.]') '.mbk'];
    pfback=[pbk fbk];
   
    %make sure files is not READONLY, or otherwise can't be opened

    pause(1.0);  %added to remove false error msg re READONLY w malab 6.1/win2000
    
    fcheck=fopen(datpath,'r+');

    if fcheck==-1

       hwarndlg=...
          warndlg('.mat  file may be READ ONLY!  To proceed, change the file properties.');
       set(hwarndlg,'unit','norm')
       set(hwarndlg,'pos', get(hwarndlg,'pos')+[0 .4 0 0] );

       newstart4;

    else

       fclose(fcheck);
       clear fcheck;

    end


    if exist(pfback)==2;      %make sure .mbk file exists (and may be a .mat file)
                              %        before checking its readonly status
       fcheck=fopen(pfback,'r+');

       if fcheck==-1

          hwarndlg2=...
             warndlg('.mbk  file may be READ ONLY!  To proceed, change the file properties.');
          set(hwarndlg2,'unit','norm')
          set(hwarndlg2,'pos', get(hwarndlg2,'pos')+[0 .4 0 0] );

          newstart4;

       else

          fclose(fcheck);
          clear fcheck;

       end 
 
    end;     %end check for file existence

    
    eval(['load ''' datpath ''' -mat'])

    set(hstatus9,'str','BACKING UP TO .mbk FILE');
    %eval(['save ''' pfback ''' tablehdr table tablemajor tableminor jin -mat']);
    eval(['save ''' pfback ''' table tablemajor tableminor jin -mat']);

    newflag=0;


    set(hstatus9,'str','READY');
  end
end

if rflag==0
  newstart4
end;

if rflag==3;
%  quit
    close all; clear; quit;
end;

