%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%plothist.m

if xtyp==1
    xmn=xmna;
    xmx=xmxa;
    ndel=ndela;
    xlab=xlaba;
    xscf=xscfa;
elseif xtyp==2
    xmn=xmnb;
    xmx=xmxb;
    ndel=ndelb;
    xlab=xlabb;
elseif xtyp==3
    xmn=xmnc;
    xmx=xmxc;
    ndel=ndelc;
    xlab=xlabc;
end

hist4;

%makeaxisplot;

figure(hf55);
set(hf55,'pos',[200 350 700 350]);
set(hf55,'numbertitle','off');

clf;

%hspno=0;

set(hf55,'name',['Length Histogram:  ' 'all species']);

hspnostr=[...
        'if ~exist(''hspno'') hspno=0; end;' ...
        'if isempty(hspno) hspno=0; end;' ...
        'if ~isnumeric(hspno) hspno=0; end;' ...
        'set(hhistspec,''str'',num2str(hspno));' ...
        'drawhist;'];

hhistspectxt=uicontrol(hf55,'style','text','un','n','pos',[.70 0.95 .25 .05], ...
    'str','enter species number (0 => all)');

hhistspec=uicontrol(hf55,'style','edit','un','n','pos',   [.95 0.95 .05 .05], ...
    'backg','w','str',num2str(hspno), ...
    'call','hspno=str2num(get( hhistspec,''str''));eval(hspnostr);');


ihsdel=1;

hlessticks=uicontrol(hf55,'style','push','un','n','pos',   [.90 0.00 .10 .05], ...
    'str','less ticks','call','ihsdel=ihsdel+1;if ihsdel>5 ihsdel=1;end;drawhist;');

hin120=uicontrol(hf55,'style','check','un','n','pos',   [.00 0.00 .20 .05], ...
    'str','include species 120','value',0,'call','drawhist;');

hnodot=uicontrol(hf55,'style','check','un','n','pos',   [.00 0.95 .20 .05], ...
    'str','show outlier dots','value',1,'call','drawhist;');



hplotaxis=axes('xtick',[]);

if xtyp==1
    bbb=blimslen;
    xlabel('length (mm)');
elseif xtyp==2
    bbb=log10(blimslen);
    xlabel('log length');
elseif xtyp==3
    bbb=log10(blimslen);
    xlabel('log length');
end

ylabel('individuals / m^3');

%hbaseline=line([bbb(1) bbb(length(bbb))],[0 0]);

%set(gca,'ylim',[-0.2 0.2]);
hold on

%initialize (w hspno = 0)
drawhist;

  


