%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%randomcells5.m
%with mods to prevent duplicate choices

%m=input('enter number of columns:  ');
%n=input('enter number of rows:  ');
%p=input('how many random cells do you want to generate?  ');

m1 = ceil(m/2);
m2 = m - m1;

n1 = ceil(n/2);
n2 = n - n1;

p4 = ceil(p/4);
 
if p4>m1*n1 | p4>m1*n2 | p4>m2*n1 | p4>m2*n2
  disp(['error:  too many cells for this grid size ' char(7)]);  %beep
  return;
end

d=zeros(m,n);

rand('state',sum(100*clock));


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hf92=92;
figure(hf92)
clf;

set(hf92,'pos',[10 10 800 400], ...
    'numbertitle','off','name','Random Cell Results');

sp1=subplot(1,2,1);
box on
set(gca,'xlim',[1 600],'ylim',[1 520])
set(gca,'xtick',[],'ytick',[],'xticklab','','yticklab','');
set(gca,'pos',[0.05 0.02 0.4 0.96]);
cla;
hold on
plot([150 150],[0 520],'k');
plot([300 300],[0 520],'k');
plot([450 450],[0 520],'k');
plot([0 600],[482 482],'k');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%quadrant 1:

a=zeros(p4,2);

i=1;
while i<=p4

  x=ceil(m1*rand(1,1));
  y=ceil(n1*rand(1,1));
  if x==0 x=1;end;
  if y==0 y=1;end;

  while d(x,y)~=0
    x=ceil(m1*rand(1,1));
    y=ceil(n1*rand(1,1));
    if x==0 x=1;end;
    if y==0 y=1;end;
  end

  d(x,y)=30;            %the secret value (yellow?)

  a(i,1)=x;
  a(i,2)=y;

  i=i+1;
end;

x0=10;
y0=510;
sza=size(a,1);

  text(x0,y0,'quad 1');
  y0=y0-19;
  text(x0,y0,' col row');
  y0=y0-19;
for ii=1:sza
  text(x0,y0,[num2str(a(ii,1)) blanks(6) num2str(a(ii,2))]);
  y0=y0-19;
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%quadrant 2:

a=zeros(p4,2);

i=1;
while i<=p4

  x=ceil(m2*rand(1,1)) + m1;
  y=ceil(n1*rand(1,1));
  if x==0 x=1;end;
  if y==0 y=1;end;

  while d(x,y)~=0
    x=ceil(m2*rand(1,1)) + m1;
    y=ceil(n1*rand(1,1));
    if x==0 x=1;end;
    if y==0 y=1;end;
  end


  d(x,y)=30;                            %the secret value (yellow?)

  a(i,1)=x;
  a(i,2)=y;

  i=i+1;
end;

x0=160;
y0=510;
sza=size(a,1);

  text(x0,y0,'quad 2');
  y0=y0-19;
  text(x0,y0,' col row');
  y0=y0-19;
for ii=1:sza
  text(x0,y0,[num2str(a(ii,1)) blanks(6) num2str(a(ii,2))]);
  y0=y0-19;
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%quadrant 3:

a=zeros(p4,2);

i=1;
while i<=p4

  x=ceil(m1*rand(1,1));
  y=ceil(n2*rand(1,1)) + n1;
  if x==0 x=1;end;
  if y==0 y=1;end;

  while d(x,y)~=0
    x=ceil(m1*rand(1,1));
    y=ceil(n2*rand(1,1)) + n1;
    if x==0 x=1;end;
    if y==0 y=1;end;
  end

  d(x,y)=30;                            %the secret value (yellow?)

  a(i,1)=x;
  a(i,2)=y;

  i=i+1;
end;

x0=310;
y0=510;
sza=size(a,1);

  text(x0,y0,'quad 3');
  y0=y0-19;
  text(x0,y0,' col row');
  y0=y0-19;
for ii=1:sza
  text(x0,y0,[num2str(a(ii,1)) blanks(6) num2str(a(ii,2))]);
  y0=y0-19;
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%quadrant 4:

a=zeros(p4,2);

i=1;
while i<=p4

  x=ceil(m2*rand(1,1)) + m1;
  y=ceil(n2*rand(1,1)) + n1;
  if x==0 x=1;end;
  if y==0 y=1;end;

  while d(x,y)~=0
    x=ceil(m2*rand(1,1)) + m1;
    y=ceil(n2*rand(1,1)) + n1;
    if x==0 x=1;end;
    if y==0 y=1;end;
  end

  d(x,y)=30;                            %the secret value (yellow?)

  a(i,1)=x;
  a(i,2)=y;

  i=i+1;
end;

x0=460;
y0=510;
sza=size(a,1);

  text(x0,y0,'quad 4');
  y0=y0-19;
  text(x0,y0,' col row');
  y0=y0-19;
for ii=1:sza
  text(x0,y0,[num2str(a(ii,1)) blanks(6) num2str(a(ii,2))]);
  y0=y0-19;
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

sp2=subplot(1,2,2);

dd = d';
image(dd);
xlabel('column');
ylabel('row');

%title(imgpath);
%all this to get rid of TeX warning msg
imgpathfixed=imgpath;
kk=0;
for ii=1:length(imgpath)
    kk=kk+1;
    if imgpath(ii)=='\'
        imgpathfixed(kk)='\';
        kk=kk+1;
        imgpathfixed(kk)='\';
    else
        imgpathfixed(kk)=imgpath(ii);
    end
end
title(imgpathfixed);

set(gca,'plotboxaspectratio',[m n 1]);
hold on
plot([0.5 m+0.5],[n1+0.5 n1+0.5],'m');
plot([m1+0.5 m1+0.5],[0.5 n+0.5],'m');

hold off
axes(sp1);
hold off

