%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%recordtable.m

legalflg = 1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%calc the length using all points

slen = 0;

if ncoord==2
  dx = clast(2,1)-clast(1,1);
  dy = clast(2,2)-clast(1,2);
  slen = sqrt( (dx*dx) + (dy*dy) );  
end;

if ncoord>2
  slen = 0;
  for i=2:ncoord
    dx = clast(i,1)-clast(i-1,1);
    dy = clast(i,2)-clast(i-1,2);
    slen = slen + sqrt( (dx*dx) + (dy*dy) );
  end;
end;


%%%%%%%%%%%%%%%%%%%%%%%%%%%
%kludge for now:  ok till next version
%convert lengths to millimeters

cpp = cmperpix;
slen = slen * cpp * 10.0; 

%%%%%%%%%%%%%%%%%%%%%%%
%make up table header info

%platesplit = [plate '.' split blanks(20-size(plate,2)-size(split,2)-1)];

%%%%%%%%%%%%%%%%%%%%%%%%
%calculate sample weight

calcweight;

%%%%%%%%%%%%%%%%%%%%%%%%%
%determine cell coords of first point

col = ceil((clast(1,1)-xgridline0)/pixpersq);
row = ceil((clast(1,2)-ygridline0)/pixpersq);

%%%%%%%%%%%%%%%%%%%%%%%
%check for space in tables and record data

if tix+1>tixmax | majorptr+ncpn>majorptrmax | minorptr+ncoord>minorptrmax
  doerror; 
else 

  tix = tix + 1;

  table(tix,1) = tix;
  table(tix,2) = spec;
  table(tix,3) = slen;
  table(tix,4) = svol;
  table(tix,5) = legalflg;
  table(tix,6) = ptmode;

  table(tix,7) = majorptr;
  table(tix,8) = ncpn;

  table(tix,9) = minorptr; 
  table(tix,10) = ncoord; 

  table(tix,11) = col;
  table(tix,12) = row;

  %tablehdr(tix,:) = platesplit;

%%%%%%%%%%%%%%%%%%%%%%%%
%save coords of major points

  for i = 1:ncpn
    tablemajor(majorptr+i-1,1) = 10*cpp*clastn(i,1);
    tablemajor(majorptr+i-1,2) = 10*cpp*clastn(i,2);
  end;

%%%%%%%%%%%%%%%%
%save all coords

  for i = 1:ncoord
    tableminor(minorptr+i-1,1) = 10*cpp*clast(i,1);
    tableminor(minorptr+i-1,2) = 10*cpp*clast(i,2);
  end;

  majorptr = majorptr + ncpn;
  minorptr = minorptr + ncoord;

end;

%%%%%%%%%%%%%%%%%%%%%%%%
%check for legal length

legalflg = 1;

if jinm.spec.slen1(currentspecindex)~=0

  %if slen<jinm.spec.slen0(currentspecindex) 
  if slen<jinm.spec.slen0(currentspecindex) | slen==0 
    legalflg = 0;
    table(tix,5)=legalflg;
    if slen~=0
        disp(['illegal length:  too short' char(beepchar)]);  %beep
    else
        disp(['illegal length:  length=0' char(beepchar)]);  %beep
    end
    illegaltix=tix;
    illegal;
  end;

  if slen>jinm.spec.slen1(currentspecindex) 
    legalflg = 0;
    table(tix,5)=legalflg;
    disp(['illegal length:  too long' char(beepchar)]);  %beep
    illegaltix=tix;
    illegal;
  end;

  %if slen==0 
  %  legalflg = 0;
  %  table(tix,5)=legalflg;
  %  disp(['illegal length:  length=0' char(beepchar)]);  %beep
  %  illegaltix=tix;
  %  illegal;
  %end;

end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%
%increse species count

if legalflg==1
  speccount(currentspecindex)=speccount(currentspecindex)+1;
  set(hu3(currentspecindex),'str',num2str(speccount(currentspecindex)));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%
%temporarily set flags to legalflg only

flags = legalflg;

%%%%%%%%%%%%%%%%%%%%%%%%%
%print info in matlab window

fprintf(1,'%4d %4d %7.3f %7.3f %4d %4d %8x %s.%s', ...
  tix,spec,slen,svol,col,row,flags,plate,split);
fprintf(1,'\n');

