%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%sethistparams.m

%disp('making histogram parameter window');

hf50=50;
figure(hf50);

set(hf50,'un','n','numb','off','menubar','none',...
   'name','Edit Plate Parameters','pos',[.1 .07 .8 .9]);

hf55=55;
set(hf50,'delete','if ishandle(hf55) delete(hf55);end;');

hspno=0;

splitnum=str2num(split);
if ~isempty(splitnum) & isnumeric(splitnum)
    splitno = splitnum;
    specsplitno = splitnum*ones(120,1);
end

listsize=size(listflag,1);

hu31h = zeros(1,listsize);
hu32h = zeros(1,listsize);
hu35h = zeros(1,listsize);

%ckboxcolor(1,:)=[1 0 0];    %red, for checkboxes with value=0 (off)
%ckboxcolor(2,:)=[0 1 0];    %green, for checkboxes with value=1 (on)

hvft=uicontrol(hf50,'un','n','style','text','pos',[.0 .96 .25 .03],...
    'backg',[.8 .8 1],'str','enter volume filtered:');

hvf=uicontrol(hf50,'un','n','style','edit','pos',[.25 .96 .05 .03],...
    'backg',[1 1 1],'str',num2str(vfilt),'call',...
     'vfilt=str2num(get(hvf,''str''));');
    %'backg',[1 1 1],'str',num2str(vfilt),'call','changevfilt');

    htct=uicontrol(hf50,'un','n','style','text','pos',[.33 .96 .25 .03],...
    'backg',[.8 .8 1],'str','enter total # of cells:');

htc=uicontrol(hf50,'un','n','style','edit','pos',[.58 .96 .05 .03],...
    'backg',[1 1 1],'str',num2str(tcells),'call','changetcells');

hspt=uicontrol(hf50,'un','n','style','text','pos',[.66 .96 .25 .03],...
    'backg',[.8 .8 1],'str','enter split factor:');

hsp=uicontrol(hf50,'un','n','style','edit','pos',[.91 .96 .05 .03],...
    'backg',[1 1 1],'str',num2str(splitno),'call','changesplit');



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%sets a, b, and c
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xtyp = 3; 
xhtyp(1,:)='linear           ';
xhtyp(2,:)='log (equal bins) ';
xhtyp(3,:)='log (std decades)';

hhtyp=uicontrol(hf50,'un','n','style','text','pos',[.10 .20 .10 .03],...
    'backg',[1 1 1],'str',xhtyp(xtyp,:));

xhtypstr1='xtyp=xtyp+1; if xtyp>3 xtyp=1;end; set(hhtyp,''str'',xhtyp(xtyp,:) );';
xhtypstr2=[ ...
    'if xtyp==1 enablea;disableb;disablec;set(hhtyp,''pos'',[.10 .20 .10 .03]);' ...
    'elseif xtyp==2 enableb;disablea;disablec;set(hhtyp,''pos'',[.10 .17 .10 .03]);' ...
    'elseif xtyp==3 enablec;disablea;disableb;set(hhtyp,''pos'',[.10 .14 .10 .03]);' ...
    'end; '] ;   
xhtypstr=[xhtypstr1 xhtypstr2];

hhtyptxt=uicontrol(hf50,'un','n','style','push','pos',[.00 .20 .10 .03],...
    'backg',[.8 .8 1],'str','select len hist type','call',xhtypstr);

hhtestplot=uicontrol(hf50,'un','n','style','push','pos',[.00 .12 .10 .03],...
    'backg',[.8 .8 1],'str','update test hist','call','testhist');
hhrealplot=uicontrol(hf50,'un','n','style','push','pos',[.00 .03 .10 .03],...
    'backg',[.8 .8 1],'str','plot hist','call','plothist');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%set a
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlaba=1;
xscfa = 5;
xhscfa(1)=0.0001;
xhscfa(2)=0.001;
xhscfa(3)=0.01;
xhscfa(4)=0.1;
xhscfa(5)=1;
xhscfa(6)=10;
xhscfa(7)=100;
xhscfa(8)=1000;
xscfupstra  ='xscfa =xscfa+1;  if xscfa>8 xscfa=1; end;   set(hscfa,''str'',num2str(xhscfa(xscfa)) )';
xscfdnstra  ='xscfa =xscfa-1;  if xscfa<1 xscfa=8; end;   set(hscfa,''str'',num2str(xhscfa(xscfa)) )';
hscftxta=uicontrol(hf50,'un','n','style','text','pos',[.80 .20 .10 .03],...
    'backg',[.8 .8 1],'str','scale factor');
hscfupa=uicontrol(hf50,'un','n','style','push','pos',[.90 .20 .02 .03],...
    'backg',[1 1 1],'str','^','call',xscfupstra);
hscfdna=uicontrol(hf50,'un','n','style','push','pos',[.92 .20 .02 .03],...
    'backg',[1 1 1],'str','v','call',xscfdnstra);
hscfa=uicontrol(hf50,'un','n','style','text','pos',[.94 .20 .06 .03],...
    'backg',[1 1 1],'str',num2str(xhscfa(xscfa)));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xmna = 0;
xmxa =  10;   %TEMP VALUES
xmnupstra  ='xmna =xmna+1;  if xmna>xmxa-1 xmna=0; end;   set(hxmna,''str'',num2str(xmna) )';
xmndnstra  ='xmna =xmna-1;  if xmna<0 xmna=xmxa-1; end;   set(hxmna,''str'',num2str(xmna) )';
hxmntxta=uicontrol(hf50,'un','n','style','text','pos',[.20 .20 .10 .03],...
    'backg',[.8 .8 1],'str','min length (mm)');
hxmna=uicontrol(hf50,'un','n','style','text','pos',[.34 .20 .06 .03],...
    'backg',[1 1 1],'str',num2str(xmna));
hxmnupa=uicontrol(hf50,'un','n','style','push','pos',[.30 .20 .02 .03],...
    'backg',[1 1 1],'str','^','call',xmnupstra);
hxmndna=uicontrol(hf50,'un','n','style','push','pos',[.32 .20 .02 .03],...
    'backg',[1 1 1],'str','v','call',xmndnstra);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ndela = 10;
xdelupstra='ndela=ndela+1; if ndela>20 ndela=1;end; set(hxdela,''str'',num2str(ndela) )';
xdeldnstra='ndela=ndela-1; if ndela<1 ndela=20;end; set(hxdela,''str'',num2str(ndela) )';
hxdeltxta=uicontrol(hf50,'un','n','style','text','pos',[.40 .20 .10 .03],...
    'backg',[.8 .8 1],'str','bins/decade');
hxdela=uicontrol(hf50,'un','n','style','text','pos',[.54 .20 .06 .03],...
    'backg',[1 1 1],'str',num2str(ndela));
hxdelupa=uicontrol(hf50,'un','n','style','push','pos',[.50 .20 .02 .03],...
    'backg',[1 1 1],'str','^','call',xdelupstra);
hxdeldna=uicontrol(hf50,'un','n','style','push','pos',[.52 .20 .02 .03],...
    'backg',[1 1 1],'str','v','call',xdeldnstra);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xmxupstra  ='xmxa =xmxa+1;  if xmxa>10 xmxa=xmna+1; end;   set(hxmxa,''str'',num2str(xmxa) )';
xmxdnstra  ='xmxa =xmxa-1;  if xmxa<xmna+1 xmxa=10; end;   set(hxmxa,''str'',num2str(xmxa) )';
hxmxtxta=uicontrol(hf50,'un','n','style','text','pos',[.60 .20 .10 .03],...
    'backg',[.8 .8 1],'str','max length (mm)');
hxmxa=uicontrol(hf50,'un','n','style','text','pos',[.74 .20 .06 .03],...
    'backg',[1 1 1],'str',num2str(xmxa));
hxmxupa=uicontrol(hf50,'un','n','style','push','pos',[.70 .20 .02 .03],...
    'backg',[1 1 1],'str','^','call',xmxupstra);
hxmxdna=uicontrol(hf50,'un','n','style','push','pos',[.72 .20 .02 .03],...
    'backg',[1 1 1],'str','v','call',xmxdnstra);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%set b
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlabb = 1;
xhlabb(1,:)='length       ';
xhlabb(2,:)='log(length)  ';
xhlabb(3,:)='len, log(len)';
xhlabb(4,:)='log(len), len';
xhlabstrb='xlabb=xlabb+1; if xlabb>4  xlabb=1;end; set(hhlabb,''str'',xhlabb(xlabb,:) )';
hhlabtxtb=uicontrol(hf50,'un','n','style','push','pos',[.80 .17 .10 .03],...
    'backg',[.8 .8 1],'str','bin label format','call',xhlabstrb);
hhlabb=uicontrol(hf50,'un','n','style','text','pos',[.90 .17 .10 .03],...
    'backg',[1 1 1],'str',xhlabb(xlabb,:));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xmnb = -4;
xmxb = 4;
xmnupstrb  ='xmnb =xmnb+1;  if xmnb>xmxb-1 xmnb=-4; end;   set(hxmnb,''str'',num2str(xmnb) )';
xmndnstrb  ='xmnb =xmnb-1;  if xmnb<-4 xmnb=xmxb-1; end;   set(hxmnb,''str'',num2str(xmnb) )';
hxmntxtb=uicontrol(hf50,'un','n','style','text','pos',[.20 .17 .10 .03],...
    'backg',[.8 .8 1],'str','log(min length)');
hxmnb=uicontrol(hf50,'un','n','style','text','pos',[.34 .17 .06 .03],...
    'backg',[1 1 1],'str',num2str(xmnb));
hxmnupb=uicontrol(hf50,'un','n','style','push','pos',[.30 .17 .02 .03],...
    'backg',[1 1 1],'str','^','call',xmnupstrb);
hxmndnb=uicontrol(hf50,'un','n','style','push','pos',[.32 .17 .02 .03],...
    'backg',[1 1 1],'str','v','call',xmndnstrb);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ndelb = 10;
xdelupstrb='ndelb=ndelb+1; if ndelb>20 ndelb=1;end; set(hxdelb,''str'',num2str(ndelb) )';
xdeldnstrb='ndelb=ndelb-1; if ndelb<1 ndelb=20;end; set(hxdelb,''str'',num2str(ndelb) )';
hxdeltxtb=uicontrol(hf50,'un','n','style','text','pos',[.40 .17 .10 .03],...
    'backg',[.8 .8 1],'str','bins/decade');
hxdelb=uicontrol(hf50,'un','n','style','text','pos',[.54 .17 .06 .03],...
    'backg',[1 1 1],'str',num2str(ndelb));
hxdelupb=uicontrol(hf50,'un','n','style','push','pos',[.50 .17 .02 .03],...
    'backg',[1 1 1],'str','^','call',xdelupstrb);
hxdeldnb=uicontrol(hf50,'un','n','style','push','pos',[.52 .17 .02 .03],...
    'backg',[1 1 1],'str','v','call',xdeldnstrb);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xmxupstrb  ='xmxb =xmxb+1;  if xmxb>4 xmxb=xmnb+1; end;   set(hxmxb,''str'',num2str(xmxb) )';
xmxdnstrb  ='xmxb =xmxb-1;  if xmxb<xmnb+1 xmxb=4; end;   set(hxmxb,''str'',num2str(xmxb) )';
hxmxtxtb=uicontrol(hf50,'un','n','style','text','pos',[.60 .17 .10 .03],...
    'backg',[.8 .8 1],'str','log(max length)');
hxmxb=uicontrol(hf50,'un','n','style','text','pos',[.74 .17 .06 .03],...
    'backg',[1 1 1],'str',num2str(xmxb));
hxmxupb=uicontrol(hf50,'un','n','style','push','pos',[.70 .17 .02 .03],...
    'backg',[1 1 1],'str','^','call',xmxupstrb);
hxmxdnb=uicontrol(hf50,'un','n','style','push','pos',[.72 .17 .02 .03],...
    'backg',[1 1 1],'str','v','call',xmxdnstrb);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%set c
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlabc = 1;
xhlabc(1,:)='length       ';
xhlabc(2,:)='log(length)  ';
xhlabc(3,:)='len, log(len)';
xhlabc(4,:)='log(len), len';
xhlabstrc='xlabc=xlabc+1; if xlabc>4  xlabc=1;end; set(hhlabc,''str'',xhlabc(xlabc,:) )';
hhlabtxtc=uicontrol(hf50,'un','n','style','push','pos',[.80 .14 .10 .03],...
    'backg',[.8 .8 1],'str','bin label format','call',xhlabstrc);
hhlabc=uicontrol(hf50,'un','n','style','text','pos',[.90 .14 .10 .03],...
    'backg',[1 1 1],'str',xhlabc(xlabc,:));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xmnc = -4;
xmxc =  4;
xmnupstrc  ='xmnc =xmnc+1;  if xmnc>xmxc-1 xmnc=-4; end;   set(hxmnc,''str'',num2str(xmnc) )';
xmndnstrc  ='xmnc =xmnc-1;  if xmnc<-4 xmnc=xmxc-1; end;   set(hxmnc,''str'',num2str(xmnc) )';
hxmntxtc=uicontrol(hf50,'un','n','style','text','pos',[.20 .14 .10 .03],...
    'backg',[.8 .8 1],'str','log(min length)');
hxmnc=uicontrol(hf50,'un','n','style','text','pos',[.34 .14 .06 .03],...
    'backg',[1 1 1],'str',num2str(xmnc));
hxmnupc=uicontrol(hf50,'un','n','style','push','pos',[.30 .14 .02 .03],...
    'backg',[1 1 1],'str','^','call',xmnupstrc);
hxmndnc=uicontrol(hf50,'un','n','style','push','pos',[.32 .14 .02 .03],...
    'backg',[1 1 1],'str','v','call',xmndnstrc);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ndelc = 10;
xdelupstrc='ndelc=ndelc+1; if ndelc>20 ndelc=1;end; set(hxdelc,''str'',num2str(ndelc) )';
xdeldnstrc='ndelc=ndelc-1; if ndelc<1 ndelc=20;end; set(hxdelc,''str'',num2str(ndelc) )';
hxdeltxtc=uicontrol(hf50,'un','n','style','text','pos',[.40 .14 .10 .03],...
    'backg',[.8 .8 1],'str','bins/decade');
hxdelc=uicontrol(hf50,'un','n','style','text','pos',[.54 .14 .06 .03],...
    'backg',[1 1 1],'str',num2str(ndelc));
hxdelupc=uicontrol(hf50,'un','n','style','push','pos',[.50 .14 .02 .03],...
    'backg',[1 1 1],'str','^','call',xdelupstrc);
hxdeldnc=uicontrol(hf50,'un','n','style','push','pos',[.52 .14 .02 .03],...
    'backg',[1 1 1],'str','v','call',xdeldnstrc);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xmxupstrc  ='xmxc =xmxc+1;  if xmxc>4 xmxc=xmnc+1; end;   set(hxmxc,''str'',num2str(xmxc) )';
xmxdnstrc  ='xmxc =xmxc-1;  if xmxc<xmnc+1 xmxc=4; end;   set(hxmxc,''str'',num2str(xmxc) )';
hxmxtxtc=uicontrol(hf50,'un','n','style','text','pos',[.60 .14 .10 .03],...
    'backg',[.8 .8 1],'str','log(max length)');
hxmxc=uicontrol(hf50,'un','n','style','text','pos',[.74 .14 .06 .03],...
    'backg',[1 1 1],'str',num2str(xmxc));
hxmxupc=uicontrol(hf50,'un','n','style','push','pos',[.70 .14 .02 .03],...
    'backg',[1 1 1],'str','^','call',xmxupstrc);
hxmxdnc=uicontrol(hf50,'un','n','style','push','pos',[.72 .14 .02 .03],...
    'backg',[1 1 1],'str','v','call',xmxdnstrc);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%initialize
xmx=xmxa;
xmn=xmna;
ndel=ndela;

eval(xhtypstr);

testhist;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hhdr=uicontrol(hf50,'un','n','style','text','pos',[.00 .90 .25 .03],...
    'backg',[.8 .8 1],'str','Species           Ncells          Splits');
hhdr=uicontrol(hf50,'un','n','style','text','pos',[.25 .90 .25 .03],...
    'backg',[.8 .8 1],'str','Species           Ncells          Splits');
hhdr=uicontrol(hf50,'un','n','style','text','pos',[.50 .90 .25 .03],...
    'backg',[.8 .8 1],'str','Species           Ncells         Splits');
hhdr=uicontrol(hf50,'un','n','style','text','pos',[.75 .90 .25 .03],...
    'backg',[.8 .8 1],'str','Species           Ncells          Splits');

blk = ' ';
%x0 = .005;
x0 = .000;
y0 = .900;
icnt = 0;

for i=1:listsize
  icnt = icnt + 1;
  %if icnt>40
  %    icnt = 1; x0 = x0 + .33; y0 = .900;
  if icnt>30
      icnt = 1; x0 = x0 + .25; y0 = .900;
  end;
  y0 = y0 - .022;
% species control
  hu31h(i) = uicontrol(hf50,'un','n','style','text','pos',[x0  y0 .10 .025], ...
                    'backgroundcolor',slc(i,:),...
                    'fontunits','norm','fontweight','bold','fontsize',0.6,...
                    'string',[num2str(sln(i)) blk sla(i,:)]);
% change number of cells sampled
  hu32h(i) = uicontrol(hf50,'un','n','style','edit',...
                    'pos',[x0+.10  y0 .08 .025], ...
                    'fontunits','norm','fontweight','bold','fontsize',0.6, ...
                    'str',ncells(i), ...
                    'user',i,'back','w','callback','changencells');
% change individual splitnos
  hu35h(i) = uicontrol(hf50,'un','n','style','edit',...
                    'pos',[x0+.18  y0 .07 .025], ...
                    'fontunits','norm','fontweight','bold','fontsize',0.6, ...
                    'str',num2str(specsplitno(i)),'user',i, ...
                    'back',[1 .8 .8],'callback','changespecsplit;');
end;

%color special buttons (and disable and set to null until future release)
for i=111:117
  %set(hu31h(i),'backg',[0.8 0.8 0.4],'enable','off','str','reserved');
  set(hu31h(i),'enable','off','str','reserved');
end

%set(hu31h(118),'backg',[0.8 0.3 0.4],'enable','off','str','reserved');
%set(hu31h(119),'backg',[0.3 0.8 0.4],'enable','off','str','reserved');
set(hu31h(118),'enable','off','str','reserved');
set(hu31h(119),'enable','off','str','reserved');

for i=111:119
  ncells(i)=1;
  specsplitno(i)=1;
  set(hu32h(i),'str',num2str(ncells(i)),'enable','off');
  set(hu35h(i),'str',num2str(specsplitno(i)),'enable','off');
end


%write histograms to a file
hwchist=uicontrol(hf50,'un','n','style','push','pos',[.0 .0 .25 .03],...
    'backg',[.7 .7 .7],'str','Write Count Histograms',...
    'call','writeasccnthist;');

hwwhist=uicontrol(hf50,'un','n','style','push','pos',[.250 .0 .25 .03],...
    'backg',[.7 .7 .7],'str','Write Weight Histograms',...
    'call','writeascwgthist;');

hwlhist=uicontrol(hf50,'un','n','style','push','pos',[.500 .0 .25 .03],...
    'backg',[.7 .7 .7],'str','Write Length Histograms',...
    'call','writeasclenhist;');


hclose =uicontrol(hf50,'un','n','style','push','pos',[.750 .0 .25 .03],...
    'backg',[.7 .7 .7],'str','Close','call','delete(hf50);');



