%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%statistics.m

%most code taken from mocstats program:

%recrete spec params
sla=jinm.spec.sla;
slc=jinm.spec.slc;
sld=jinm.spec.sld;
sln=jinm.spec.sln;
slen0=jinm.spec.slen0;
slen1=jinm.spec.slen1;
listflag=jinm.spec.listflag;

%first save the most recent sample points (see createcontrols.m)

writetable3;
savecount=0;

%code from loaddata.m

a = zeros(tixmax,12);
a(:,:) = table;

speccnt=zeros(120,1);
calcspeccnt;

%code from docells.m

clen=cell(1,120);
cwgt=cell(1,120);

%  find max entry in each mat file, and use it to save time below
%  (theres probably a safer way to do this,e.g, start at tixmax and
%  look backward for 1st non-zero value.)

%    first, do the "pure" (non-combo) plates (w data from only one file)
%    then do combo plates

%for i=1:dht
    
    maxn=size( find(a(:,1) ~= 0 ) , 1);
    ix1=find( a(1:maxn,8) >= 0 );  %elim invalid measurements (counts<0)
    temp1=a(ix1,:);

    for j=1:110
    %for j=1:119
      ix2=find(temp1(:,2)==j);  %find samples with species code j
      temp2=temp1(ix2,:);   %NOTE transposed cell contents
      clen{j}=temp2(find(temp2(:,3)~=0),3)';  %cull out samples w length=0
      %cwgt{j}=temp2(find(temp2(:,3)~=0),4); revert to culling all wgt=0s
      cwgt{j}=temp2(find(temp2(:,4)~=0),4)';  %cull out zero weights
      %don't want to do this any more, because always want same number of
      %entries in length and weight tables, even if some weights are 0.
      %instead, elim weight entries if LENGTH entry is zero
    end;
    
%special case;  look for species code 999   
    j=120;
    ix2=find(temp1(:,2)==999);
    temp2=temp1(ix2,:);
    clen{j}=temp2(:,3)'; %if code 999, then
    cwgt{j}=temp2(:,4)'; %  leave in samples w length=0
    
%when cwgt is empty (because no volfn exists) fill cwgt with zeros
%this ought to be done  by placing zeros in default.wgt file
    %for j=1:120
    %  if isempty(cwgt{j})
    %    cwgt{j}=zeros(size(clen{j}));
    % end;
    %end;

    %end;

%do subtotals for codes 111 to 119

for sublix=1:9
    clen{sublix+110}=[clen{sublist{sublix}}];
    cwgt{sublix+110}=[cwgt{sublist{sublix}}];
end

%code from stats4.m (formerly dostats4.m)

lencnt =zeros(1,120);
lenmin =zeros(1,120);
lenmax =zeros(1,120);
lenavg =zeros(1,120);
lenstds=zeros(1,120);
lenstdp=zeros(1,120);

wgtcnt =zeros(1,120);
wgtmin =zeros(1,120);
wgtmax =zeros(1,120);
wgtavg =zeros(1,120);
wgtstds=zeros(1,120);
wgtstdp=zeros(1,120);

%for i=1:dht

  for j=1:120
    if length(clen{j}) > 1   %possible bug; mixes up 1X2 vs. 2X1 cell
      lencnt (1,j)=length(clen{j});   
      lenmin (1,j)=min (clen{j});    
      lenmax (1,j)=max (clen{j});    
      lenavg (1,j)=mean(clen{j});
      lenstds(1,j)=std (clen{j});
      lenstdp(1,j)=std (clen{j},1);
    end
    if length(clen{j}) == 1
      lencnt (1,j)=length(clen{j});   
      lenmin (1,j)=min (clen{j});    
      lenmax (1,j)=max (clen{j});    
      lenavg (1,j)=clen{j};
      lenstds(1,j)=clen{j};
      lenstdp(1,j)=0;
    end
    if length(cwgt{j}) > 1   %possible bug; mixes up 1X2 vs. 2X1 cell
      wgtcnt (1,j)=length(cwgt{j});   
      wgtmin (1,j)=min (cwgt{j});    
      wgtmax (1,j)=max (cwgt{j});    
      wgtavg (1,j)=mean(cwgt{j});
      wgtstds(1,j)=std (cwgt{j});
      wgtstdp(1,j)=std (cwgt{j},1);
    end
    if length(cwgt{j}) == 1
      wgtcnt (1,j)=length(cwgt{j});   
      wgtmin (1,j)=min (cwgt{j});    
      wgtmax (1,j)=max (cwgt{j});    
      wgtavg (1,j)=cwgt{j};
      wgtstds(1,j)=cwgt{j};
      wgtstdp(1,j)=0;
    end
  end
  
  %end

%disp('statistics complete');

%now ready to run writeasclens of writeascwgts

