%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%writeasccnthist.m

%calc histogram data
%mods 8/8/01 to optionally omit cols 111-119

hist4;

fss=0;
pss=0;

[fss,pss]=uiputfile([imgdir '*.txt'],'Select COUNT HISTOGRAM Spreadsheet File');

if (isempty(fss) | fss==0)  disp('no file selected');return;end;

%fss = [fss '.txt'];

%strip off ".txt"s
fss = stripext(fss,'.txt');

%check to see if the REVISED filename matches an existing file
fileisopen=0;                %file-opened flag
dirlist=dir(pss);      %get dir listing
dirlistlen=size(dirlist,1);  %get dir length
for idir=1:dirlistlen        %check each entry for matching filename
    tempname=dirlist(idir).name;   %convert last 4 chars of filename to lower case   
    tempnamelen=length(tempname);
    if tempnamelen >= 4
        tempname(tempnamelen-3:tempnamelen) = ...
                 lower( tempname(tempnamelen-3:tempnamelen) ); 
    end
    if strcmp(tempname,fss)        %see if there is a match
        reply11=questdlg(...
         ['Do you REALLY want to OVERWRITE file:    ' pss fss],'WARNING','yes','no','no');
        if strcmp(reply11,'yes')
            f2=fopen([pss fss],'w');
            fileisopen=1;
        else
            disp('no file selected')
            return;   %start over
        end
    end
end

%if file is not already opened, open it now
if fileisopen==0
    f2=fopen([pss fss],'w');
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fprintf(f2,'COUNT_HISTOGRAM_SPREADSHEET\r\n');
%fprintf(f2,'\r\n');
fprintf(f2,'File:   %s\r\n',datfil);
%fprintf(f2,'\r\n');
fprintf(f2,'Directory:   %s\r\n',datdir);
%fprintf(f2,'\r\n');
fprintf(f2,'Plate:   %s\r\n',plate);
%fprintf(f2,'\r\n');
fprintf(f2,'\r\n');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fprintf(f2,'Parameters all_species ');
for n=1:lastcol
  fprintf(f2,'%s ',[num2str(sln(n)) '-' sla(n,:)]);
end
%  fprintf(f2,'%s ',[num2str(sln(120)) '-' sla(120,:)]);
%fprintf(f2,'\r\n');
fprintf(f2,'\r\n');

fprintf(f2,'vol_filt(m^3) ');
%fprintf(f2,'xxx ');
fprintf(f2,'%g ',vfilt);
for n=1:lastcol
  fprintf(f2,'%g ',vfilt);
end
%  fprintf(f2,'%g ',vfilt);
fprintf(f2,'\r\n');

fprintf(f2,'num_cells ');
%fprintf(f2,'xxx ');
fprintf(f2,'%g ',tcells);
for n=1:lastcol
  fprintf(f2,'%g ',ncells(n) );
end
%  fprintf(f2,'%g ',ncells(120));
fprintf(f2,'\r\n');

fprintf(f2,'split_fact ');
%fprintf(f2,'xxx ');
fprintf(f2,'%g ',splitno);
for n=1:lastcol
  fprintf(f2,'%g ',specsplitno(n) );
end
%  fprintf(f2,'%g ',specsplitno(120));
fprintf(f2,'\r\n');

fprintf(f2,'\r\n');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fprintf(f2,'Length_Stats all_species ');
for n=1:lastcol
  fprintf(f2,'%s ',[num2str(sln(n)) '-' sla(n,:)]);
end
%  fprintf(f2,'%s ',[num2str(sln(120)) '-' sla(120,:)]);
%fprintf(f2,'\r\n');
fprintf(f2,'\r\n');

fprintf(f2,'count ');
fprintf(f2,'xxx ');
for n=1:lastcol
  fprintf(f2,'%g ',lencnt(:,n));
end
%  fprintf(f2,'%g ',lencnt(:,120));
fprintf(f2,'\r\n');

fprintf(f2,'mean(mm) ');
fprintf(f2,'xxx ');
for n=1:lastcol
  fprintf(f2,'%g ',lenavg(:,n));
end
%  fprintf(f2,'%g ',lenavg(:,120));
fprintf(f2,'\r\n');

fprintf(f2,'max(mm) ');
fprintf(f2,'xxx ');
for n=1:lastcol
  fprintf(f2,'%g ',lenmax(:,n));
end
%  fprintf(f2,'%g ',lenmax(:,120));
fprintf(f2,'\r\n');

fprintf(f2,'min(mm) ');
fprintf(f2,'xxx ');
for n=1:lastcol
  fprintf(f2,'%g ',lenmin(:,n));
end
%  fprintf(f2,'%g ',lenmin(:,120));
fprintf(f2,'\r\n');


if stdflg==1
    
    fprintf(f2,'samp_std(mm) ');
    fprintf(f2,'xxx ');
    for n=1:lastcol
        fprintf(f2,'%g ',lenstds(:,n));
    end
%   fprintf(f2,'%g ',lenstds(:,120));
    fprintf(f2,'\r\n');
    
    fprintf(f2,'popl_std(mm) ');
    fprintf(f2,'xxx ');
    for n=1:lastcol
        fprintf(f2,'%g ',lenstdp(:,n));
    end
%       fprintf(f2,'%g ',lenstdp(:,120));
    fprintf(f2,'\r\n');

end

%fprintf(f2,'\r\n');
fprintf(f2,'\r\n');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fprintf(f2,'ABUNDANCE_DISTRIBUTIONS_BY_WEIGHT,_');
fprintf(f2,'corrected_for_cells_counted,_split_factor,_and_volume_filtered. ');    
fprintf(f2,'\r\n');   
fprintf(f2,'__Units__=__individuals/meter^3');
%fprintf(f2,'\r\n');
fprintf(f2,'\r\n');

%print no wgt flags

fprintf(f2,'wt_formula_avail? xxx ');
for i=1:lastcol
    if nowgtflag(i)==0 fprintf(f2,'yes '); else fprintf(f2,'NO ');end;
end
%fprintf(f2,'\r\n');
fprintf(f2,'\r\n');

fprintf(f2,'Weight_Bin(mg),Lower_Limit all_species ');
for i=1:lastcol
  fprintf(f2,'%s ',clab(i,:));
end
%  fprintf(f2,'%s ',clab(120,:));
fprintf(f2,'\r\n');

for j=1:nwgtbins
 fprintf(f2,'%s ',rlab(j,:));
 %fprintf(f2,'%g ',sum(corwgtcnt([1:lastcol 120],j)));
 fprintf(f2,'%g ',sum(corwgtcnt([1:lastcol    ],j)));
 for i=1:lastcol
    fprintf(f2,'%g ',corwgtcnt(i,j));
  end
  %  fprintf(f2,'%g ',corwgtcnt(120,j));
  fprintf(f2,'\r\n');
end

%fprintf(f2,'\r\n');

fprintf(f2,'%s ','Total_Counts_for_all_weight_bins');
%fprintf(f2,'\r\n');
fprintf(f2,'\r\n');

fprintf(f2,'%s ','wgt_formulas_only');
%fprintf(f2,'%g ',sum(corwgtcnttot([1:lastcol 120])));
fprintf(f2,'%g ',sum(corwgtcnttot([1:lastcol    ])));
for i=1:lastcol
  fprintf(f2,'%g ',corwgtcnttot(i));
end
%fprintf(f2,'%g ',corwgtcnttot(120));
fprintf(f2,'\r\n');

fprintf(f2,'%s ','all');
%fprintf(f2,'%g ',sum(corlrncnttot([1:lastcol 120])));
fprintf(f2,'%g ',sum(corlencnttot([1:lastcol    ])));
for i=1:lastcol
  fprintf(f2,'%g ',corlencnttot(i));
end
%fprintf(f2,'%g ',corlencnttot(120));
fprintf(f2,'\r\n');

fclose(f2);

fprintf(1,'ascii count histograms written in spreadsheet format to file\n');
fprintf(1,'  %s\n',[pss fss]);
fprintf(1,'\n');

