%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%writeascstats.m
%mods 8/8/01 to omit cols 111-119

fss=0;
pss=0;

[fss,pss]=uiputfile([imgdir '*.txt'],'Select STATISTICS Spreadsheet File');

if (isempty(fss) | fss==0)  disp('no file selected');return;end;

%fss = [fss '.txt'];

%strip off ".txt"s
fss = stripext(fss,'.txt');

%check to see if the REVISED filename matches an existing file
fileisopen=0;                      %file-opened flag
dirlist=dir(pss);                  %get dir listing
dirlistlen=size(dirlist,1);        %get dir length
for idir=1:dirlistlen              %check each entry for matching filename
    tempname=dirlist(idir).name;   %convert last 4 chars of filename to lower case   
    tempnamelen=length(tempname);
    if tempnamelen >= 4
        tempname(tempnamelen-3:tempnamelen) = ...
                 lower( tempname(tempnamelen-3:tempnamelen) ); 
    end
    if strcmp(tempname,fss)        %see if there is a match
        reply11=questdlg(...
         ['Do you REALLY want to OVERWRITE file:    ' pss fss],'WARNING','yes','no','no');
        if strcmp(reply11,'yes')
            f2=fopen([pss fss],'w');
            fileisopen=1;
        else
            disp('no file selected')
            return;   %start over
        end
    end
end

%if file is not already opened, open it now
if fileisopen==0
    f2=fopen([pss fss],'w');
end;


fprintf(f2,'LENGTH_STATISTICS\r\n');
%fprintf(f2,'\r\n');
fprintf(f2,'File:   %s\r\n',datfil);
%fprintf(f2,'\r\n');
fprintf(f2,'Directory:   %s\r\n',datdir);
%fprintf(f2,'\r\n');
fprintf(f2,'Plate:   %s\r\n',plate);
%fprintf(f2,'\r\n');
fprintf(f2,'\r\n');

fprintf(f2,'Statistic ');
for n=1:lastcol
  fprintf(f2,'%s ',[num2str(sln(n)) '-' sla(n,:)]);
end
  fprintf(f2,'%s ',[num2str(sln(120)) '-' sla(120,:)]);
fprintf(f2,'\r\n');

fprintf(f2,'count ');
for n=1:lastcol
  fprintf(f2,'%g ',lencnt(:,n));
end
  fprintf(f2,'%g ',lencnt(:,120));
fprintf(f2,'\r\n');

fprintf(f2,'mean(mm) ');
for n=1:lastcol
  fprintf(f2,'%g ',lenavg(:,n));
end
  fprintf(f2,'%g ',lenavg(:,120));
fprintf(f2,'\r\n');

fprintf(f2,'max(mm) ');
for n=1:lastcol
  fprintf(f2,'%g ',lenmax(:,n));
end
  fprintf(f2,'%g ',lenmax(:,120));
fprintf(f2,'\r\n');

fprintf(f2,'min(mm) ');
for n=1:lastcol
  fprintf(f2,'%g ',lenmin(:,n));
end
  fprintf(f2,'%g ',lenmin(:,120));
fprintf(f2,'\r\n');


if stdflg==1
    
    fprintf(f2,'samp_std(mm) ');
    for n=1:lastcol
        fprintf(f2,'%g ',lenstds(:,n));
    end
    fprintf(f2,'\r\n');
    
    fprintf(f2,'popl_std(mm) ');
    for n=1:lastcol
        fprintf(f2,'%g ',lenstdp(:,n));
    end
    fprintf(f2,'\r\n');

end

fclose(f2);

fprintf(1,'stats written in spreadsheet format to file\n');
fprintf(1,'  %s\n',[pss fss]);
fprintf(1,'\n');

